# File Name: PA4_autograder.py
# Author: Jonathan Morse

# Used to access command line arguments 
import sys
sys.path.insert(0, '../')
from autograder_core import *
# Allows shell commands
import subprocess
# Allows access to file system
import os

def main(grader_first_name,grader_last_name,student_file_name):

    # Initializing values of earned points by students on tasks for project

    task_one_score_earned = 0
    task_two_score_earned = 0
    task_three_score_earned = 0
    task_four_score_earned = 0 
    task_five_score_earned = 0 
    task_six_score_earned = 0 
    task_seven_score_earned = 0
    task_eight_score_earned = 0 
    task_nine_score_earned = 0 
    task_ten_score_earned = 0 

    # Initializing values of possible points that a student could 
    # earn on tasks for project

    task_one_score_possible = 5
    task_two_score_possible = 5
    task_three_score_possible = 5
    task_four_score_possible = 5
    task_five_score_possible = 5
    task_six_score_possible = 5
    task_seven_score_possible = 5
    task_eight_score_possible = 5 
    task_nine_score_possible = 5
    task_ten_score_possible = 10

    # Initializing reason for score variables for tasks

    task_one_reason_for_score = ""
    task_two_reason_for_score = ""
    task_three_reason_for_score = ""
    task_four_reason_for_score = ""
    task_five_reason_for_score = ""
    task_six_reason_for_score = ""
    task_seven_reason_for_score = ""
    task_eight_reason_for_score = ""
    task_nine_reason_for_score = ""
    task_ten_reason_for_score = ""

    # Opens the rubric text file
    r = open("../Output_Files/Rubrics/%s_PA4_rubric.txt" \
        % (student_file_name), "w")
    # Creates header
    r.write(str(header("FOUR",
    	               student_file_name,
                       grader_first_name,
                       grader_last_name,
    	               "Forty Five(45) or Fifty Five(55) with extra credit"
    	               )))
    # Task 1
    r.write(str(task_create("One",
    	                   "Correct compilation using make and" \
                           + " g++ -Wall without warnings",
    	                   task_one_score_possible,
    	                   task_one_score_earned,
    	                   task_one_reason_for_score
    	                   )))
    # Task 2
    r.write(str(task_create("Two",
    	                   "Correct use of random number generator" \
                           + " and seed",
    	                   task_two_score_possible,
    	                   task_two_score_earned,
    	                   task_two_reason_for_score
    	                   )))
    # Task 3
    r.write(str(task_create("Three",
    	                   "Satisfactory program organization into an " \
                           + "understandable set of functions and modules" \
                           + "(i.e. .cpp and .h files) and satisfactory " \
                           + "use of symbolic constants",
    	                   task_three_score_possible,
    	                   task_three_score_earned,
    	                   task_three_reason_for_score
    	                   )))
    # Task 4
    r.write(str(task_create("Four",
    	                   "Satisfactory class definitions to represent " \
                           + "Events, Customers, and Tellers",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 5 
    r.write(str(task_create("Five","Satisfactory implementation of event " \
                           + "queue, including insertion in time order",
    	                   task_five_score_possible,
    	                   task_five_score_earned,
    	                   task_five_reason_for_score
    	                   ))) 
    # Task 6
    r.write(str(task_create("Six",
    	                   "Satisfactory implementation and use of action " \
                           "methods for Tellers and Customers",
    	                   task_six_score_possible,
    	                   task_six_score_earned,
    	                   task_six_reason_for_score
    	                   )))
    # Task 7 
    r.write(str(task_create("Seven",
    	                   "Evidence of satisfactory testing, including " \
                           + "output from test cases",
    	                   task_seven_score_possible,
    	                   task_seven_score_earned,
    	                   task_seven_reason_for_score
    	                   )))
    # Task 8
    r.write(str(task_create("Eight",
    	                   "Correct execution with graders’ test cases",
    	                   task_eight_score_possible,
    	                   task_eight_score_earned,
    	                   task_eight_reason_for_score
    	                   )))
    # Task 9
    r.write(str(task_create("Nine",
    	                   "Satisfactory README file describing your class " \
                           + "definitions and including a discussion of " \
                           + "the merits of common or per-teller queuing",
    	                   task_nine_score_possible,
    	                   task_nine_score_earned,
    	                   task_nine_reason_for_score
                           )))
    # Task 10 (Extra Credit)
    r.write(str(task_create("Ten",
    	                   "Define and implement the eventQueue class " \
                           "using the priority_queue class from the " \
                           "Standard Template Library",
    	                   task_ten_score_possible,
    	                   task_ten_score_earned,
    	                   task_ten_reason_for_score
    	                   )))

    return;

main(sys.argv[1],sys.argv[2],sys.argv[3])