# File Name: PA5_autograder.py
# Author: Jonathan Morse

# Used to access command line arguments 
import sys
sys.path.insert(0, '../')
from autograder_core import *
# Allows shell commands
import subprocess
# Allows access to file system
import os


def main(grader_first_name,grader_last_name,student_file_name):

    # Initializing values of earned points by students on tasks for project

    task_one_score_earned = 0
    task_one_part_one_score_earned = 0
    task_one_part_two_score_earned = 0
    task_one_part_three_score_earned = 0
    task_one_part_four_score_earned = 0
    task_two_score_earned = 0
    task_two_part_one_score_earned = 0
    task_two_part_two_score_earned = 0
    task_two_part_three_score_earned = 0
    task_two_part_four_score_earned = 0
    task_three_score_earned = 0
    task_three_part_one_score_earned = 0
    task_three_part_two_score_earned = 0
    task_three_part_three_score_earned = 0
    task_four_score_earned = 0 
    task_five_score_earned = 0 
    task_six_score_earned = 0 

    # Initializing values of possible points that a student could 
    # earn on tasks for project

    task_one_score_possible = 25
    task_one_part_one_score_possible = 4
    task_one_part_two_score_possible = 6
    task_one_part_three_score_possible = 13
    task_one_part_four_score_possible = 2
    task_two_score_possible = 10
    task_two_part_one_score_possible = 3
    task_two_part_two_score_possible = 3
    task_two_part_three_score_possible = 3
    task_two_part_four_score_possible = 1
    task_three_score_possible = 10
    task_three_part_one_score_possible = 3
    task_three_part_two_score_possible = 4
    task_three_part_three_score_possible = 3
    task_four_score_possible = 5
    task_five_score_possible = 10
    task_six_score_possible = 5

    # Initializing reason for score variables for tasks

    task_one_reason_for_score = ""
    task_one_part_one_reason_for_score = ""
    task_one_part_two_reason_for_score = ""
    task_one_part_three_reason_for_score = ""
    task_one_part_four_reason_for_score = ""
    task_two_reason_for_score = ""
    task_two_part_one_reason_for_score = ""
    task_two_part_two_reason_for_score = ""
    task_two_part_three_reason_for_score = ""
    task_two_part_four_reason_for_score = ""
    task_three_reason_for_score = ""
    task_three_part_one_reason_for_score = ""
    task_three_part_two_reason_for_score = ""
    task_three_part_three_reason_for_score = ""
    task_four_reason_for_score = ""
    task_five_reason_for_score = ""
    task_six_reason_for_score = ""

    # Opens the rubric text file
    r = open("../Output_Files/Rubrics/%s_PA5_rubric.txt" \
        % (student_file_name), "w")
    # Creates header
    r.write(str(header("FIVE",
                       student_file_name,
                       grader_first_name,
                       grader_last_name,
    	               "Fifty(50) or Sixty(65) with extra credit"
    	               )))
    # Task 1
    r.write(str(task_create("One",
    	                   "The Rational Class:",
    	                   task_one_score_possible,
    	                   task_one_score_earned,
    	                   task_one_reason_for_score
    	                   )))
    # Task 1 Part 1
    r.write(str(task_create("One Part One",
    	                   "Correct definition of class and methods, " \
                           + "and overloaded operators",
    	                   task_one_part_one_score_possible,
    	                   task_one_part_one_score_earned,
    	                   task_one_part_one_reason_for_score
    	                   )))
    # Task 1 Part 2
    r.write(str(task_create("One Part Two",
    	                   "Correct implementation of four different" \
                           + "constructors, of one destructor, and an " \
                           + "internal normalization method",
    	                   task_one_part_two_score_possible,
    	                  task_one_part_two_score_earned,
    	                   task_one_part_two_reason_for_score
    	                   )))
    # Task 1 Part 3
    r.write(str(task_create("One Part Three",
    	                   "Correct implementation of 13 operators (i.e.," \
                           + " <<, >>, !=, ==, <, <=, >, >=, +, –, *, /, " \
                           + "and conversion to double)",
    	                   task_one_part_three_score_possible,
    	                   task_one_part_three_score_earned,
    	                   task_one_part_three_reason_for_score
    	                   )))
    # Task 1 Part 4
    r.write(str(task_create("One Part Four",
    	                   "Compile without warnings using",
    	                   task_one_part_four_score_possible,
    	                   task_one_part_four_score_earned,
    	                   task_one_part_four_reason_for_score
    	                   )))
    # Task 2
    r.write(str(task_create("Two",
    	                   "The Test Program: ",
    	                   task_two_score_possible,
    	                   task_two_score_earned,
    	                   task_two_reason_for_score
    	                   )))
    # Task 2 Part 1
    r.write(str(task_create("Two Part One",
    	                   "Correct processing of command lines, opening " \
                           + "and closing of input files",
    	                   task_two_part_one_score_possible,
    	                   task_two_part_one_score_earned,
    	                   task_two_part_one_reason_for_score
    	                   )))
    # Task 2 Part 2
    r.write(str(task_create("Two Part Two",
    	                   "Correct scanning and parsing of input lines",
    	                   task_two_part_two_score_possible,
    	                   task_two_part_two_score_earned,
    	                   task_two_part_two_reason_for_score
    	                   )))
    # Task 2 Part 3
    r.write(str(task_create("Two Part Three",
    	                   "Correct evaluation of parsed input lines and " \
                           + "output of results",
    	                   task_two_part_three_score_possible,
    	                   task_two_part_three_score_earned,
    	                   task_two_part_three_reason_for_score
    	                   )))
    # Task 2 Part 4
    r.write(str(task_create("Two Part Four",
    	                   "Compile without warnings using –Wall",
    	                   task_two_part_four_score_possible,
    	                   task_two_part_four_score_earned,
    	                   task_two_part_four_reason_for_score
    	                   )))
    # Task 3
    r.write(str(task_create("Three",
    	                   "Test Cases:",
    	                   task_three_score_possible,
    	                   task_three_score_earned,
    	                   task_three_reason_for_score
    	                   )))
    # Task 3 Part 1
    r.write(str(task_create("Three Part One",
    	                   "Enough lines in test files to exercise each " \
                           "comparison operation at least 3 times with " \
                           "a range of input values",
    	                   task_three_part_one_score_possible,
    	                   task_three_part_one_score_earned,
    	                   task_three_part_one_reason_for_score
    	                   )))
    # Task 3 Part 2
    r.write(str(task_create("Three Part Two",
    	                   "Enough lines in test files to exercise each " \
                           + "arithmetic operator (+, –, *, /) at least " \
                           + "three times with non-trivial denominators, " \
                           + "including denominators that are relatively " \
                           + "prime and those that are not relatively prime",
    	                   task_three_part_two_score_possible,
    	                   task_three_part_two_score_earned,
    	                   task_three_part_two_reason_for_score
    	                   )))
    # Task 3 Part 3
    r.write(str(task_create("Three Part Three",
    	                   "Enough test cases to show that normalization " \
                           + "works in all situations",
    	                   task_three_part_three_score_possible,
    	                   task_three_part_three_score_earned,
    	                   task_three_part_three_reason_for_score
    	                   )))
    # Task 4
    r.write(str(task_create("Four",
    	                   "Satisfactory README file explaining your class " \
                           + "and your testing and showing the output of " \
                           + "all test cases",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 5 (Extra Credit 1)
    r.write(str(task_create("Five (Extra Credit)",
    	                   "Define and implement the assignment operators " \
                           + "=, +=, -=, *=, and /=. Also, construct test " \
                           + "cases that show that they work. Then extend " \
                           + "the input lines of the test cases to include " \
                           + "simple variables that can be assigned to on " \
                           + "one line and used on later lines of the same " \
                           + "test case.",
    	                   task_five_score_possible,
    	                   task_five_score_earned,
    	                   task_five_reason_for_score
    	                   )))
    # Task 6 (Extra Credit 2)
    r.write(str(task_create("Six (Extra Credit)",
    	                   "Implement a friend function to overload the " \
                           + "assignment operator to assign a rational " \
                           + "number to a double. Extend the test program " \
                           + "to demonstrate that this works. In your " \
                           + "README document, ex-plain how your tested " \
                           + "it and how the graders can replicate " \
                           + "you tests.",
    	                   task_six_score_possible,
    	                   task_six_score_earned,
    	                   task_six_reason_for_score
    	                   )))
    return;

main(sys.argv[1],sys.argv[2],sys.argv[3])