# File Name: PA6_autograder.py
# Author: Jonathan Morse

# Used to access command line arguments 
import sys
sys.path.insert(0, '../')
from autograder_core import *
# Allows shell commands
import subprocess
# Allows access to file system
import os

def main(grader_first_name,grader_last_name,student_file_name):

    # Initializing values of earned points by students on tasks for project

    task_one_score_earned = 0
    task_one_part_one_score_earned = 0
    task_two_score_earned = 0
    task_two_part_one_score_earned = 0
    task_two_part_two_score_earned = 0
    task_two_part_three_score_earned = 0
    task_three_score_earned = 0
    task_three_part_one_score_earned = 0
    task_three_part_two_score_earned = 0
    task_three_part_three_score_earned = 0
    task_three_part_four_score_earned = 0
    task_four_score_earned = 0 
    task_four_part_one_score_earned = 0
    task_four_part_two_score_earned = 0
    task_four_part_three_score_earned = 0
    task_four_part_four_score_earned = 0
    task_five_score_earned = 0 
    task_six_score_earned = 0 

    # Initializing values of possible points that a student could earn on tasks for project

    task_one_score_possible = 5
    task_one_part_one_score_possible = 5
    task_two_score_possible = 9
    task_two_part_one_score_possible = 3
    task_two_part_two_score_possible = 3
    task_two_part_three_score_possible = 3
    task_three_score_possible = 3
    task_three_part_one_score_possible = 3
    task_three_part_two_score_possible = 3
    task_three_part_three_score_possible = 3
    task_three_part_four_score_possible = 3
    task_four_score_possible = 15
    task_four_part_one_score_possible = 5
    task_four_part_two_score_possible = 5
    task_four_part_three_score_possible = 3
    task_four_part_four_score_possible = 2
    task_five_score_possible = 10
    task_six_score_possible = 5

    # Initializing reason for score variables for tasks

    task_one_reason_for_score = ""
    task_one_part_one_reason_for_score = ""
    task_two_reason_for_score = ""
    task_two_part_one_reason_for_score = ""
    task_two_part_two_reason_for_score = ""
    task_two_part_three_reason_for_score = ""
    task_three_reason_for_score = ""
    task_three_part_one_reason_for_score = ""
    task_three_part_two_reason_for_score = ""
    task_three_part_three_reason_for_score = ""
    task_three_part_four_reason_for_score = ""
    task_four_reason_for_score = ""
    task_four_part_one_reason_for_score = ""
    task_four_part_two_reason_for_score = ""
    task_four_part_three_reason_for_score = ""
    task_four_part_four_reason_for_score = ""
    task_five_reason_for_score = ""
    task_six_reason_for_score = ""

    # Opens the rubric text file
    r = open("../Output_Files/Rubrics/%s_PA6_rubric.txt"
        % (student_file_name), "w")
    # Creates header
    r.write(str(header("SIX",
    	               student_file_name,
                       grader_first_name,
                       grader_last_name,
    	               "Fifty(50)"
    	               )))
    # Task 1
    r.write(str(task_create("One",
    	                   "The abstract organism class:",
    	                   task_one_score_possible,
    	                   task_one_score_earned,
    	                   task_one_reason_for_score
    	                   )))
    # Task 1 Part 1
    r.write(str(task_create("One Part One",
    	                   "Correct definition of class and virtual methods",
    	                   task_one_part_one_score_possible,
    	                   task_one_part_one_score_earned,
    	                   task_one_part_one_reason_for_score
    	                   )))
    # Task 2
    r.write(str(task_create("Two",
    	                   "The ant subclass: ",
    	                   task_two_score_possible,
    	                   task_two_score_earned,
    	                   task_two_reason_for_score
    	                   )))
    # Task 2 Part 1
    r.write(str(task_create("Two Part One",
    	                   "Correct definition of subclass",
    	                   task_two_part_one_score_possible,
    	                   task_two_part_one_score_earned,
    	                   task_two_part_one_reason_for_score
    	                   )))
    # Task 2 Part 2
    r.write(str(task_create("Two Part Two",
    	                   "Correct implementation of move() function",
    	                   task_two_part_two_score_possible,
    	                   task_two_part_two_score_earned,
    	                   task_two_part_two_reason_for_score
    	                   )))
    # Task 2 Part 3
    r.write(str(task_create("Two Part Three",
    	                   "Correct implementation of breeding",
    	                   task_two_part_three_score_possible,
    	                   task_two_part_three_score_earned,
    	                   task_two_part_three_reason_for_score
    	                   )))
    # Task 3
    r.write(str(task_create("Three",
    	                   "The doodlebug subclass",
    	                   task_three_score_possible,
    	                   task_three_score_earned,
    	                   task_three_reason_for_score
    	                   )))
    # Task 3 Part 1
    r.write(str(task_create("Three Part One",
    	                   "Correct definition of subclass",
    	                   task_three_part_one_score_possible,
    	                   task_three_part_one_score_earned,
    	                   task_three_part_one_reason_for_score
    	                   )))
    # Task 3 Part 2
    r.write(str(task_create("Three Part Two",
    	                   "Correct implementation of move() function",
    	                   task_three_part_two_score_possible,
    	                   task_three_part_two_score_earned,
    	                   task_three_part_two_reason_for_score
    	                   )))
    # Task 3 Part 3
    r.write(str(task_create("Three Part Three",
    	                   "Correct implementation of breeding",
    	                   task_three_part_three_score_possible,
    	                   task_three_part_three_score_earned,
    	                   task_three_part_three_reason_for_score
    	                   )))
    # Task 3 Part 4
    r.write(str(task_create("Three Part Four",
    	                   "Correct implementation of eating",
    	                   task_three_part_four_score_possible,
    	                   task_three_part_four_score_earned,
    	                   task_three_part_four_reason_for_score
    	                   )))
    # Task 4
    r.write(str(task_create("Four",
    	                   "Simulation framework",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 4 Part 1
    r.write(str(task_create("Four Part One",
    	                   "Grid implementation",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 4 Part 2
    r.write(str(task_create("Four Part Two",
    	                   "Primary simulation loop invoking the move() methods of organisms",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 4 Part 3
    r.write(str(task_create("Four Part Three",
    	                   "Processing command line arguments and setting up initial configuration",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 4 Part 4
    r.write(str(task_create("Four Part Four",
    	                   "Satisfactory output of steps of the simulation",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 5 
    r.write(str(task_create("Five",
    	                   "Satisfactory README file explaining your class and your testing and showing the output of all test cases",
    	                   task_five_score_possible,
    	                   task_five_score_earned,
    	                   task_five_reason_for_score
    	                   )))
    # Task 6
    r.write(str(task_create("Six",
    	                   "Satisfactory execution of graders’ test cases",
    	                   task_six_score_possible,
    	                   task_six_score_earned,
    	                   task_six_reason_for_score
    	                   )))
    return;

main(sys.argv[1],sys.argv[2],sys.argv[3])